=== debian/changelog ===
kid3 (3.5.1-1) unstable; urgency=medium

  * New upstream release.
    - Adjust install files.
  * Bump Standards-Version to 4.1.1 (no changes required).
  * Remove trailing whitespaces from debian/changelog.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 07 Nov 2017 10:24:02 +0100
